(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? module.exports = factory(require('../../../../src/polyfills.js')) :
  typeof define === 'function' && define.amd ? define(['../../../../src/polyfills.js'], factory) :
  (global.AmpAccessIframeApi = factory());
}(this, (function () { 'use strict';

  var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();
  function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
  var AccessController = function () {
    function AccessController() {
      _classCallCheck(this, AccessController);
    }
    _createClass(AccessController, [{
      key: "connect",
      value: function connect(origin, protocol, config) {}
    }, {
      key: "authorize",
      value: function authorize() {}
    }, {
      key: "pingback",
      value: function pingback() {}
    }]);
    return AccessController;
  }();

  var _createClass$1 = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();
  function _classCallCheck$1(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
  var SENTINEL = '__AMP__';
  var Messenger = function () {
    function Messenger(win, targetOrCallback, targetOrigin) {
      _classCallCheck$1(this, Messenger);
      this.win_ = win;
      this.targetOrCallback_ = targetOrCallback;
      this.targetOrigin_ = targetOrigin;
      this.target_ = null;
      this.onCommand_ = null;
      this.boundHandleEvent_ = this.handleEvent_.bind(this);
      this.requestId_ = 0;
      this.waiting_ = {};
    }
    _createClass$1(Messenger, [{
      key: 'connect',
      value: function connect(onCommand) {
        if (this.onCommand_) {
          throw new Error('already connected');
        }
        this.onCommand_ = onCommand;
        this.win_.addEventListener('message', this.boundHandleEvent_);
      }
    }, {
      key: 'disconnect',
      value: function disconnect() {
        if (this.onCommand_) {
          this.onCommand_ = null;
          this.win_.removeEventListener('message', this.boundHandleEvent_);
        }
      }
    }, {
      key: 'isConnected',
      value: function isConnected() {
        return this.targetOrigin_ != null;
      }
    }, {
      key: 'getTarget',
      value: function getTarget() {
        var target = this.getOptionalTarget_();
        if (!target) {
          throw new Error('not connected');
        }
        return target;
      }
    }, {
      key: 'getOptionalTarget_',
      value: function getOptionalTarget_() {
        if (this.onCommand_ && !this.target_) {
          if (typeof this.targetOrCallback_ == 'function') {
            this.target_ = this.targetOrCallback_();
          } else {
            this.target_ =                       this.targetOrCallback_;
          }
        }
        return this.target_;
      }
    }, {
      key: 'getTargetOrigin',
      value: function getTargetOrigin() {
        if (this.targetOrigin_ == null) {
          throw new Error('not connected');
        }
        return this.targetOrigin_;
      }
    }, {
      key: 'sendCommand',
      value: function sendCommand(cmd, opt_payload) {
        this.sendCommand_(             undefined, cmd, opt_payload);
      }
    }, {
      key: 'sendCommandRsvp',
      value: function sendCommandRsvp(cmd, opt_payload) {
        var rsvpId = String(++this.requestId_);
        var resolver = void 0;
        var promise = new Promise(function (resolve) {
          resolver = resolve;
        });
        this.waiting_[rsvpId] = {
          promise: promise,
          resolver: resolver
        };
        this.sendCommand_(rsvpId, cmd, opt_payload);
        return promise;
      }
    }, {
      key: 'sendCommand_',
      value: function sendCommand_(rsvpId, cmd, opt_payload) {
        var target = this.getTarget();
        var targetOrigin = cmd == 'connect' ? this.targetOrigin_ != null ? this.targetOrigin_ : '*' : this.getTargetOrigin();
        target.       postMessage(                           {
          'sentinel': SENTINEL,
          '_rsvp': rsvpId,
          'cmd': cmd,
          'payload': opt_payload || null
        }, targetOrigin);
      }
    }, {
      key: 'handleEvent_',
      value: function handleEvent_(e) {
        var _this = this;
        var event =                             e;
        var data = event.data;
        if (!data || data['sentinel'] != SENTINEL) {
          return;
        }
        var origin =                      event.origin;
        var cmd = data['cmd'];
        var payload = data['payload'] || null;
        if (this.targetOrigin_ == null && cmd == 'start') {
          this.targetOrigin_ = origin;
        }
        if (this.targetOrigin_ == null && event.source) {
          if (this.getOptionalTarget_() == event.source) {
            this.targetOrigin_ = origin;
          }
        }
        if (origin != this.targetOrigin_) {
          return;
        }
        var rsvpId = data['_rsvp'];
        var rsvp = !!rsvpId && cmd != 'rsvp';
        var result = this.handleCommand_(rsvpId, cmd, payload);
        if (rsvp) {
          Promise.resolve(result).then(function (result) {
            _this.sendCommand_(rsvpId, 'rsvp', {
              'result': result
            });
          }, function (reason) {
            _this.sendCommand_(rsvpId, 'rsvp', {
              'error': String(reason)
            });
          });
        }
      }
    }, {
      key: 'handleCommand_',
      value: function handleCommand_(rsvpId, cmd, payload) {
        if (cmd == 'rsvp') {
          var waiting = rsvpId && this.waiting_[rsvpId];
          if (waiting) {
            if ('error' in payload) {
              waiting.resolver(Promise.reject(new Error(payload['error'])));
            } else {
              waiting.resolver(payload['result']);
            }
            delete this.waiting_[rsvpId];
          }
          return;
        }
        return this.onCommand_(cmd, payload);
      }
    }]);
    return Messenger;
  }();

  var _createClass$2 = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();
  function _classCallCheck$2(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
  var AmpAccessIframeApi = function () {
    function AmpAccessIframeApi(controller, opt_win) {
      var _this = this;
      _classCallCheck$2(this, AmpAccessIframeApi);
      if (!controller) {
        throw new Error('controller must be specified');
      }
      this.controller_ = controller;
      this.win_ = opt_win || window;
      this.target_ = this.win_.parent;
      this.messenger_ = new Messenger(this.win_, this.target_,
                        null);
      this.config_ = null;
      this.protocol_ = null;
      this.connectedResolver_ = null;
      this.connectedPromise_ = new Promise(function (resolve) {
        _this.connectedResolver_ = resolve;
      });
    }
    _createClass$2(AmpAccessIframeApi, [{
      key: 'connect',
      value: function connect() {
        this.messenger_.connect(this.handleCommand_.bind(this));
        this.messenger_.sendCommand('connect');
        return this.connectedPromise_;
      }
    }, {
      key: 'disconnect',
      value: function disconnect() {
        this.messenger_.disconnect();
      }
    }, {
      key: 'handleCommand_',
      value: function handleCommand_(cmd, payload) {
        var _this2 = this;
        if (cmd == 'start') {
          this.config_ = payload['config'];
          this.protocol_ = payload['protocol'];
          var promise = new Promise(function (resolve) {
            resolve(_this2.controller_.connect(_this2.messenger_.getTargetOrigin(), _this2.protocol_, _this2.config_));
          });
          this.connectedResolver_(promise);
          return promise;
        }
        if (cmd == 'close') {
          this.disconnect();
          return;
        }
        if (cmd == 'authorize') {
          return new Promise(function (resolve) {
            resolve(_this2.controller_.authorize());
          });
        }
        if (cmd == 'pingback') {
          if (!this.controller_.pingback) {
            return null;
          }
          return new Promise(function (resolve) {
            resolve(_this2.controller_.pingback());
          }).then(function () {});
        }
      }
    }]);
    return AmpAccessIframeApi;
  }();

  return AmpAccessIframeApi;

})));
